import { LitElement } from 'lit';
import { Pen } from '@infinite-canvas-tutorial/ecs';
import '@shoelace-style/shoelace/dist/components/spinner/spinner.js';
import '@shoelace-style/shoelace/dist/components/icon/icon.js';
import '@shoelace-style/shoelace/dist/components/resize-observer/resize-observer.js';
import '@shoelace-style/shoelace/dist/components/alert/alert.js';
/**
 * @see https://shoelace.style/getting-started/themes
 */
import '@shoelace-style/shoelace/dist/themes/light.css';
import '@shoelace-style/shoelace/dist/themes/dark.css';
export declare class InfiniteCanvas extends LitElement {
    #private;
    static styles: import("lit").CSSResult;
    renderer: 'webgl' | 'webgpu';
    theme: 'dark' | 'light';
    shaderCompilerPath: string;
    shoelaceBasePath: string;
    zoom: number;
    pen: Pen;
    pens: Pen[];
    connectedCallback(): void;
    disconnectedCallback(): void;
    private resize;
    private initCanvas;
    render(): import("lit").TemplateResult<1>;
}
declare global {
    interface HTMLElementTagNameMap {
        'ic-shoelace-canvas': InfiniteCanvas;
    }
}
