var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { html, css, LitElement } from 'lit';
import { customElement, property } from 'lit/decorators.js';
import '@shoelace-style/shoelace/dist/components/button-group/button-group.js';
import '@shoelace-style/shoelace/dist/components/tooltip/tooltip.js';
import '@shoelace-style/shoelace/dist/components/icon-button/icon-button.js';
import { Event } from '../event';
let ZoomToolbar = class ZoomToolbar extends LitElement {
    constructor() {
        super(...arguments);
        this.zoom = 1;
    }
    zoomOut() {
        const event = new CustomEvent(Event.ZOOM_OUT, {
            bubbles: true,
            composed: true,
            cancelable: true,
        });
        this.dispatchEvent(event);
    }
    zoomIn() {
        const event = new CustomEvent(Event.ZOOM_IN, {
            bubbles: true,
            composed: true,
            cancelable: true,
        });
        this.dispatchEvent(event);
    }
    render() {
        return html `
      <sl-button-group label="Zoom toolbar">
        <sl-tooltip content="Zoom out">
          <sl-icon-button
            name="dash-lg"
            label="Zoom out"
            @click=${this.zoomOut}
          ></sl-icon-button>
        </sl-tooltip>
        <span>${Math.round(this.zoom * 100)}%</span>
        <sl-tooltip content="Zoom in">
          <sl-icon-button
            name="plus-lg"
            label="Zoom in"
            @click=${this.zoomIn}
          ></sl-icon-button>
        </sl-tooltip>
      </sl-button-group>
    `;
    }
};
ZoomToolbar.styles = css `
    :host {
      box-shadow: var(--sl-shadow-medium);
      background: var(--sl-panel-background-color);
    }

    span {
      font-size: 12px;
      line-height: 32px;
      width: 32px;
      text-align: center;
      color: var(--sl-color-neutral-600);
    }
  `;
__decorate([
    property({ type: Number })
], ZoomToolbar.prototype, "zoom", void 0);
ZoomToolbar = __decorate([
    customElement('ic-shoelace-zoom-toolbar')
], ZoomToolbar);
export { ZoomToolbar };
//# sourceMappingURL=zoom-toolbar.js.map