var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { html, css, LitElement } from 'lit';
import { customElement } from 'lit/decorators.js';
import { appStateContext, Task } from '../context';
import { consume } from '@lit/context';
import '@spectrum-web-components/icons-workflow/icons/sp-icon-close.js';
import { Event } from '../event';
let LayersPanel = class LayersPanel extends LitElement {
    handleClose() {
        this.dispatchEvent(new CustomEvent(Event.TASK_CHANGED, {
            detail: {
                selected: this.appState.taskbar.selected.filter((task) => task !== Task.SHOW_LAYERS_PANEL),
            },
            bubbles: true,
            composed: true,
            cancelable: true,
        }));
    }
    render() {
        return this.appState.taskbar.selected.includes(Task.SHOW_LAYERS_PANEL)
            ? html `<section>
          <h4>
            Layers
            <sp-action-button quiet size="s" @click=${this.handleClose}>
              <sp-icon-close slot="icon"></sp-icon-close>
            </sp-action-button>
          </h4>
        </section>`
            : null;
    }
};
LayersPanel.styles = css `
    section {
      display: flex;
      flex-direction: column;
      background: var(--spectrum-gray-100);
      border-radius: var(--spectrum-corner-radius-200);

      padding: var(--spectrum-global-dimension-size-100);
      margin: 4px;

      filter: drop-shadow(
        var(--spectrum-drop-shadow-color) 0px var(--spectrum-drop-shadow-y)
          var(--spectrum-drop-shadow-blur)
      );
    }

    h4 {
      display: flex;
      align-items: center;
      justify-content: space-between;
      margin: 0;
    }
  `;
__decorate([
    consume({ context: appStateContext, subscribe: true })
], LayersPanel.prototype, "appState", void 0);
LayersPanel = __decorate([
    customElement('ic-spectrum-layers-panel')
], LayersPanel);
export { LayersPanel };
//# sourceMappingURL=layers-panel.js.map