var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { co, DOMAdapter, PreStartUp, RasterScreenshotRequest, Screenshot, System, VectorScreenshotRequest, } from '@infinite-canvas-tutorial/ecs';
export class DownloadScreenshotSystem extends System {
    // container: LitElement;
    constructor() {
        super();
        this.screenshot = this.singleton.read(Screenshot);
        this.rasterScreenshotRequest = this.singleton.write(RasterScreenshotRequest);
        this.vectorScreenshotRequest = this.singleton.write(VectorScreenshotRequest);
        this.schedule((s) => s.before(PreStartUp));
    }
    initialize() {
        // this.container.addEventListener(Event.SCREENSHOT_REQUESTED, (e) => {
        //   if (e.detail instanceof RasterScreenshotRequest) {
        //     Object.assign(this.rasterScreenshotRequest, e.detail);
        //     this.setScreenshotTrigger(this.rasterScreenshotRequest);
        //   } else if (e.detail instanceof VectorScreenshotRequest) {
        //     Object.assign(this.vectorScreenshotRequest, e.detail);
        //     this.setScreenshotTrigger(this.vectorScreenshotRequest);
        //   }
        // });
    }
    execute() {
        // if (this.screenshot.dataURL) {
        //   this.downloadImage('infinite-canvas-screenshot', this.screenshot.dataURL);
        //   this.container.dispatchEvent(
        //     new CustomEvent(Event.SCREENSHOT_DOWNLOADED, {
        //       detail: {
        //         dataURL: this.screenshot.dataURL,
        //       },
        //     }),
        //   );
        // }
    }
    *setScreenshotTrigger(screenshotRequest) {
        Object.assign(screenshotRequest, { enabled: true });
        yield;
        Object.assign(screenshotRequest, { enabled: false });
    }
    downloadImage(defaultFilename, dataURL) {
        const mimeType = dataURL.substring(dataURL.indexOf(':') + 1, dataURL.indexOf(';'));
        const suffix = mimeType.split('/')[1];
        // g-svg only support .svg
        const isSVG = dataURL.startsWith('data:image/svg');
        const fileName = `${defaultFilename}.${isSVG ? 'svg' : suffix}`;
        const link = DOMAdapter.get()
            .getDocument()
            .createElement('a');
        if (isSVG) {
            link.addEventListener('click', () => {
                link.download = fileName;
                link.href = dataURL;
            });
        }
        else if (window.Blob && window.URL) {
            const arr = dataURL.split(',');
            let mime = '';
            if (arr && arr.length > 0) {
                const match = arr[0].match(/:(.*?);/);
                // eslint-disable-next-line prefer-destructuring
                if (match && match.length >= 2)
                    mime = match[1];
            }
            const bstr = atob(arr[1]);
            let n = bstr.length;
            const u8arr = new Uint8Array(n);
            while (n--) {
                u8arr[n] = bstr.charCodeAt(n);
            }
            const blobObj = new Blob([u8arr], { type: mime });
            // account for IE
            // @see https://stackoverflow.com/a/41434373
            if (navigator.msSaveBlob) {
                navigator.msSaveBlob(blobObj, fileName);
            }
            else {
                link.addEventListener('click', () => {
                    link.download = fileName;
                    link.href = window.URL.createObjectURL(blobObj);
                });
            }
        }
        // trigger click
        if (link.click) {
            link.click();
        }
        else {
            const e = DOMAdapter.get().getDocument().createEvent('MouseEvents');
            e.initEvent('click', false, false);
            link.dispatchEvent(e);
        }
    }
}
__decorate([
    co
], DownloadScreenshotSystem.prototype, "setScreenshotTrigger", null);
//# sourceMappingURL=DownloadScreenshot.js.map