"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Exporter = void 0;
const lit_1 = require("lit");
const decorators_js_1 = require("lit/decorators.js");
const ecs_1 = require("@infinite-canvas-tutorial/ecs");
require("@shoelace-style/shoelace/dist/components/dropdown/dropdown.js");
require("@shoelace-style/shoelace/dist/components/menu/menu.js");
require("@shoelace-style/shoelace/dist/components/menu-item/menu-item.js");
require("@shoelace-style/shoelace/dist/components/switch/switch.js");
require("@shoelace-style/shoelace/dist/components/icon-button/icon-button.js");
const event_1 = require("../event");
let Exporter = class Exporter extends lit_1.LitElement {
    constructor() {
        super(...arguments);
        this.grid = false;
    }
    handleInputChange() {
        this.grid = !this.grid;
    }
    connectedCallback() {
        super.connectedCallback();
        this.addEventListener('sl-select', (event) => __awaiter(this, void 0, void 0, function* () {
            const selectedItem = event.detail.item;
            let detail;
            if (selectedItem.value === 'download-image-png' ||
                selectedItem.value === 'download-image-jpeg') {
                detail = new ecs_1.RasterScreenshotRequest();
                detail.type = `image/${selectedItem.value.split('-').reverse()[0]}`;
            }
            else {
                detail = new ecs_1.VectorScreenshotRequest();
            }
            detail.grid = this.grid;
            this.dispatchEvent(new CustomEvent(event_1.Event.SCREENSHOT_REQUESTED, {
                detail,
                bubbles: true,
                composed: true,
            }));
        }));
    }
    render() {
        return (0, lit_1.html) `<sl-dropdown>
      <sl-icon-button
        slot="trigger"
        name="download"
        label="Download"
      ></sl-icon-button>
      <sl-menu>
        <sl-switch
          size="small"
          .checked=${this.grid}
          @sl-input=${this.handleInputChange}
          >Grids included</sl-switch
        >
        <sl-menu-item value="download-image-png"
          >Download PNG image</sl-menu-item
        >
        <sl-menu-item value="download-image-jpeg"
          >Download JPEG image</sl-menu-item
        >
        <sl-menu-item value="download-image-svg"
          >Download SVG image</sl-menu-item
        >
      </sl-menu>
    </sl-dropdown>`;
    }
};
exports.Exporter = Exporter;
Exporter.styles = (0, lit_1.css) `
    :host {
      box-shadow: var(--sl-shadow-medium);
      background: var(--sl-panel-background-color);
    }

    sl-switch {
      margin-left: 24px;
      color: var(--sl-color-neutral-700);
    }

    sl-menu-item::part(base) {
      font-size: 14px;
    }
  `;
__decorate([
    (0, decorators_js_1.state)()
], Exporter.prototype, "grid", void 0);
exports.Exporter = Exporter = __decorate([
    (0, decorators_js_1.customElement)('ic-shoelace-exporter')
], Exporter);
//# sourceMappingURL=image-exporter.js.map