"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PenToolbar = void 0;
const lit_1 = require("lit");
const decorators_js_1 = require("lit/decorators.js");
const class_map_js_1 = require("lit/directives/class-map.js");
const map_js_1 = require("lit/directives/map.js");
require("@shoelace-style/shoelace/dist/components/button-group/button-group.js");
require("@shoelace-style/shoelace/dist/components/tooltip/tooltip.js");
require("@shoelace-style/shoelace/dist/components/icon-button/icon-button.js");
const ecs_1 = require("@infinite-canvas-tutorial/ecs");
const event_1 = require("../event");
const PEN_LIST = [
    { name: ecs_1.Pen.HAND, label: 'Move', icon: 'arrows-move' },
    { name: ecs_1.Pen.SELECT, label: 'Select', icon: 'cursor' },
    { name: ecs_1.Pen.DRAW_RECT, label: 'Draw rectangle', icon: 'square' },
];
let PenToolbar = class PenToolbar extends lit_1.LitElement {
    changePen(pen) {
        const detail = { pen };
        const event = new CustomEvent(event_1.Event.PEN_CHANGED, {
            detail,
            bubbles: true,
            composed: true,
            cancelable: true,
        });
        this.dispatchEvent(event);
    }
    render() {
        const pens = this.pens.map((name) => PEN_LIST.find((item) => item.name === name));
        return (0, lit_1.html) `
      <sl-button-group label="Zoom toolbar">
        ${(0, map_js_1.map)(pens, ({ name, label, icon }) => {
            const classes = { active: this.pen === name };
            return (0, lit_1.html) `<sl-tooltip content=${label}>
            <sl-icon-button
              class=${(0, class_map_js_1.classMap)(classes)}
              name=${icon}
              label=${label}
              @click="${() => this.changePen(name)}"
            ></sl-icon-button>
          </sl-tooltip>`;
        })}
      </sl-button-group>
    `;
    }
};
exports.PenToolbar = PenToolbar;
PenToolbar.styles = (0, lit_1.css) `
    :host {
      box-shadow: var(--sl-shadow-medium);
      background: var(--sl-panel-background-color);
    }

    span {
      font-size: 12px;
      line-height: 32px;
      width: 32px;
      text-align: center;
      color: var(--sl-color-neutral-600);
    }

    .active {
      background: var(--sl-color-neutral-200);
    }
  `;
__decorate([
    (0, decorators_js_1.property)()
], PenToolbar.prototype, "pen", void 0);
__decorate([
    (0, decorators_js_1.property)({ type: Array })
], PenToolbar.prototype, "pens", void 0);
exports.PenToolbar = PenToolbar = __decorate([
    (0, decorators_js_1.customElement)('ic-shoelace-pen-toolbar')
], PenToolbar);
//# sourceMappingURL=pen-toolbar.js.map