"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Penbar = void 0;
const lit_1 = require("lit");
const decorators_js_1 = require("lit/decorators.js");
const map_js_1 = require("lit/directives/map.js");
const context_1 = require("@lit/context");
const ecs_1 = require("@infinite-canvas-tutorial/ecs");
const context_2 = require("../context");
const event_1 = require("../event");
require("@spectrum-web-components/action-group/sp-action-group.js");
require("@spectrum-web-components/icons-workflow/icons/sp-icon-hand.js");
require("@spectrum-web-components/icons-workflow/icons/sp-icon-select.js");
require("@spectrum-web-components/icons-workflow/icons/sp-icon-shapes.js");
const PenMap = {
    [ecs_1.Pen.HAND]: {
        icon: (0, lit_1.html) `<sp-icon-hand slot="icon"></sp-icon-hand>`,
        label: 'Hand (Panning tool)',
    },
    [ecs_1.Pen.SELECT]: {
        icon: (0, lit_1.html) `<sp-icon-select slot="icon"></sp-icon-select>`,
        label: 'Select',
    },
    [ecs_1.Pen.DRAW_RECT]: {
        icon: (0, lit_1.html) `<sp-icon-shapes slot="icon"></sp-icon-shapes>`,
        label: 'Shapes',
    },
};
let Penbar = class Penbar extends lit_1.LitElement {
    handlePenChanged(e) {
        const event = new CustomEvent(event_1.Event.PEN_CHANGED, {
            detail: { selected: e.target.selected },
            bubbles: true,
            composed: true,
            cancelable: true,
        });
        this.dispatchEvent(event);
    }
    render() {
        const { all, selected } = this.appState.penbar;
        return (0, lit_1.html) `
      <sp-action-group
        vertical
        selects="single"
        .selected=${selected}
        @change=${this.handlePenChanged}
        emphasized
        quiet
      >
        ${(0, map_js_1.map)(all, (pen) => {
            const { icon, label } = PenMap[pen];
            return (0, lit_1.html) `<sp-action-button value="${pen}">
            ${icon}
            <sp-tooltip self-managed placement="right"> ${label} </sp-tooltip>
          </sp-action-button>`;
        })}
      </sp-action-group>
    `;
    }
};
exports.Penbar = Penbar;
Penbar.styles = (0, lit_1.css) `
    :host {
      display: flex;
      justify-content: center;

      background: var(--spectrum-gray-100);
      border-radius: var(--spectrum-corner-radius-200);

      padding: var(--spectrum-global-dimension-size-100);
      margin: 4px;

      filter: drop-shadow(
        var(--spectrum-drop-shadow-color) 0px var(--spectrum-drop-shadow-y)
          var(--spectrum-drop-shadow-blur)
      );
    }
  `;
__decorate([
    (0, context_1.consume)({ context: context_2.appStateContext, subscribe: true })
], Penbar.prototype, "appState", void 0);
exports.Penbar = Penbar = __decorate([
    (0, decorators_js_1.customElement)('ic-spectrum-penbar')
], Penbar);
//# sourceMappingURL=penbar.js.map