"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PropertiesPanel = void 0;
const lit_1 = require("lit");
const decorators_js_1 = require("lit/decorators.js");
const context_1 = require("../context");
const context_2 = require("@lit/context");
require("@spectrum-web-components/accordion/sp-accordion.js");
require("@spectrum-web-components/accordion/sp-accordion-item.js");
require("@spectrum-web-components/icons-workflow/icons/sp-icon-close.js");
const event_1 = require("../event");
let PropertiesPanel = class PropertiesPanel extends lit_1.LitElement {
    handleClose() {
        this.dispatchEvent(new CustomEvent(event_1.Event.TASK_CHANGED, {
            detail: {
                selected: this.appState.taskbar.selected.filter((task) => task !== context_1.Task.SHOW_PROPERTIES_PANEL),
            },
            bubbles: true,
            composed: true,
            cancelable: true,
        }));
    }
    render() {
        return this.appState.taskbar.selected.includes(context_1.Task.SHOW_PROPERTIES_PANEL)
            ? (0, lit_1.html) `<section>
          <h4>
            Properties
            <sp-action-button quiet size="s" @click=${this.handleClose}>
              <sp-icon-close slot="icon"></sp-icon-close>
            </sp-action-button>
          </h4>
          <sp-accordion allow-multiple size="s">
            <sp-accordion-item label="Transform"> </sp-accordion-item>
          </sp-accordion>
        </section>`
            : null;
    }
};
exports.PropertiesPanel = PropertiesPanel;
PropertiesPanel.styles = (0, lit_1.css) `
    section {
      display: flex;
      flex-direction: column;
      background: var(--spectrum-gray-100);
      border-radius: var(--spectrum-corner-radius-200);

      padding: var(--spectrum-global-dimension-size-100);
      margin: 4px;

      filter: drop-shadow(
        var(--spectrum-drop-shadow-color) 0px var(--spectrum-drop-shadow-y)
          var(--spectrum-drop-shadow-blur)
      );
    }

    h4 {
      display: flex;
      align-items: center;
      justify-content: space-between;
      margin: 0;
    }
  `;
__decorate([
    (0, context_2.consume)({ context: context_1.appStateContext, subscribe: true })
], PropertiesPanel.prototype, "appState", void 0);
exports.PropertiesPanel = PropertiesPanel = __decorate([
    (0, decorators_js_1.customElement)('ic-spectrum-properties-panel')
], PropertiesPanel);
//# sourceMappingURL=properties-panel.js.map